/*
 * Copyright (c) 2007, 2008 by Hartmut Birr
 *
 * This program is free software; you can redistribute it and/or
 * mmodify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA. 
 *
 */


#include "avr/io.h"
#include "avr/interrupt.h"

.global TIMER1_COMPA_vect
.func TIMER1_COMPA_vect
TIMER1_COMPA_vect:
										// 2	2
	push	R20							// 2    4
	push	R30							// 2    6
	push	R31							// 2    8
	
	lds		R30, ptr_int				// 2    10
	lds		R31, (ptr_int+1)			// 2    12
	
	ld		R20, Z+						// 2    14
	sts		_SFR_MEM_ADDR(OCR1AH), R20	// 2	16
	ld		R20, Z+						// 2	18
	sts		_SFR_MEM_ADDR(OCR1AL), R20	// 2	20

	ld		R20, Z+						// 2	22
	out		_SFR_IO_ADDR(PORTB), R20	// 1	23
	ld		R20, Z+						// 2	25
	out		_SFR_IO_ADDR(PORTC), R20	// 1	26
	ld		R20, Z+						// 2	28
	out		_SFR_IO_ADDR(PORTD), R20	// 1	29

	sts		ptr_int, R30				// 2    31	  
	sts		(ptr_int+1), R31			// 2    33

	pop		R31							// 2    35
	pop		R30							// 2    37
	pop		R20							// 2    39
	    
	reti								// 4	41
.endfunc								//
	                            		// |    |
										// |    +------------------> Anzahl der Zyklen im Interrupt
										// +-----------------------> Anzahl der Zyklen fr den aktuellen Kode	

.global TIMER1_COMPB_vect
.func TIMER1_COMPB_vect
TIMER1_COMPB_vect:

										// 2	2
	push	R20							// 2    4
	push	R30							// 2    6
	push	R31							// 2    8

	lds		R30, ptr_next				// 2    10	
	lds		R31, (ptr_next+1)			// 2    12

	ld		R20, Z+						// 2    14
	sts		_SFR_MEM_ADDR(OCR1AH), R20	// 2	16
	ld		R20, Z+						// 2	18
	sts		_SFR_MEM_ADDR(OCR1AL), R20	// 2	20
	
	ld		R20, Z+						// 2	22
	out		_SFR_IO_ADDR(PORTB), R20	// 1	23
	ld		R20, Z+						// 2	25
	out		_SFR_IO_ADDR(PORTC), R20	// 1	26
	ld		R20, Z+						// 2	38
	out		_SFR_IO_ADDR(PORTD), R20	// 1	29
	
	sts		ptr_int, R30				// 2    31	  
	sts		(ptr_int+1), R31			// 2    33

	pop		R31							// 2    35
	pop		R30							// 2    37
	pop		R20							// 2    39
	    
	reti								// 4	41
.endfunc

.end

